function love.load()
   love.graphics.setBackgroundColor(255, 0, 255)
   canvas = love.graphics.newCanvas(400,300)
   love.graphics.setLineWidth(5)
   move_right = true
   xpos = 0
end

function love.update(dt)
	if xpos+50 > 400 then
		move_right = false
	elseif
		xpos < 0 then
		move_right = true
	end
	
	if move_right then
		xpos = xpos + 100*dt
	else 
		xpos = xpos - 100*dt
	end
end

function love.draw()
	canvas:clear(0,0,0,255)
	--lighting canvas
	love.graphics.setCanvas(canvas)
	love.graphics.setBlendMode("additive")
    love.graphics.setColor(0, 255, 0,150)
    love.graphics.rectangle("fill", 75, 75, 125, 125)
	love.graphics.setBlendMode("subtractive")
    love.graphics.setColor(0, 0, 0,150)
    love.graphics.rectangle("fill", 75, 75, 125, 125)
    love.graphics.setColor(0, 0, 0,175)
    love.graphics.rectangle("fill", xpos, 110, 125, 125)
	--outside lighting canvas
	love.graphics.setCanvas()
	love.graphics.setBlendMode("alpha")
	love.graphics.setColor(0, 255, 0,255)
	love.graphics.line(0,0,500,500)
	love.graphics.setColor(0, 0, 255,255)
	love.graphics.line(0,100,500,100)
	love.graphics.setColor(255, 255, 255,255)
	love.graphics.draw(canvas)
end